var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    initialiseDrawingParams();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $($(document)).on("input","#crypto", function(){
        drawBasicScreen();
    });

    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
    
    $("[type='number']").keypress(function (evt) {
        evt.preventDefault();
    });
} 

function initialiseGUI(){

}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
}

function drawBasicScreen(){
    //cntx.clearRect(0,0,canvas.width,canvas.height);
    //Φόντα οθόνης
    if(!(IntroStep==IntroLastStep && mouseMoving)){
        cntx.clearRect(0,0,canvas.width,canvas.height);
        drawIntroImage();
    }
    if(IntroStep==IntroLastStep){
        if(!mouseMoving){
            $("#controlsDiv").show();
            cntx.strokeStyle="red";
            var Xinit=appletWidth/2;
            var Yinit=BottomPanelTop;
            useColors=$("#colorise").prop("checked");
            DrawTree1(0,Xinit,Yinit,0,0);
        }
    }
    else{
        $("#controlsDiv").hide();
    }
    cntx.clearRect(0,0,canvas.width,TopPanelHeight);
    cntx.clearRect(0,BottomPanelTop,canvas.width,BottomPanelHeight);
    drawBorders();
    drawLogoImage();
    if(IntroStep<IntroLastStep) drawButtonNext();
    if(IntroStep>1) drawButtonBack();
    showUserPrompts();
}

function drawIntroImage(){
    if(IntroStep<IntroLastStep){
        Intro=document.getElementById("img"+IntroStep);
        picTop=(height-Intro.height)/2;
        cntx.drawImage(Intro,1,picTop);
    }
    else{
        cntx.fillStyle="white";
        cntx.fillRect(1,TopPanelHeight,appletWidth,BottomPanelTop-TopPanelHeight);
    }
}

function drawBorders(){
    cntx.strokeStyle="black";
    cntx.beginPath();
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
    mouseMoving=false;
}

function handleMouseMove(){
    mouseMoving=true;
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    drawBasicScreen();
    if(debug) console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    else{
        if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && IntroStep<IntroLastStep) {
            IntroStep++;
        }
        if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && IntroStep>1) {
            IntroStep--;
        }
        mouseMoving=false;
        drawBasicScreen();
    }
}

function showUserPrompts(){
    var hTxtOffset=BackStepLeft+BackStepWidth+Border;
    var vTxtOffset=15;
    var promptYCoord;
    if(IntroStep==IntroLastStep){
        promptYCoord=BottomPanelTop+40;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Μπορείς να αυξήσεις την πιθανότητα διακλάδωσης με τη μπάρα κύλισης. Ποια τιμή δίνει καλύτερα αποτέλεσματα;");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Χρησιμοποίησε το διακόπτη [Χρωματισμός] για πιο ρεαλιστικό αποτέλεσμα.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Με το κουμπί [Νέο Σχέδιο] μπορείς να παράγεις διαφορετικά δέντρα κατά τρόπο τυχαίο.");
    }
}


function DrawTree1(Selector,Xinit,Yinit,Angle,Counter){     
    var BasicSize=10;
    var X1,Y1,X2,Y2,X3,Y3,X4,Y4;
    var XX1,YY1,XX2,YY2,XX3,YY3,XX4,YY4;
    var P;
    if(Selector==0){
      X1=0;
      Y1=0;
      X2=X1;
      Y2=Y1-BasicSize;
      X3=X1-BasicSize;
      Y3=Y2-BasicSize;
      X4=X1+BasicSize;
      Y4=Y2-BasicSize;
      
      XX1=Rotate(X1,Y1,Angle,1);
      YY1=Rotate(X1,Y1,Angle,2);

      XX2=Rotate(X2,Y2,Angle,1);
      YY2=Rotate(X2,Y2,Angle,2);
      
      XX3=Rotate(X3,Y3,Angle,1);
      YY3=Rotate(X3,Y3,Angle,2);

      XX4=Rotate(X4,Y4,Angle,1);
      YY4=Rotate(X4,Y4,Angle,2);

      if(useColors) cntx.strokeStyle=WoodColor; //backg.setColor(WoodColor);
      cntx.beginPath();
      //backg.drawLine(XX1+Xinit,YY1+Yinit,XX2+Xinit,YY2+Yinit);
      cntx.moveTo(XX1+Xinit,YY1+Yinit);
      cntx.lineTo(XX2+Xinit,YY2+Yinit);
      //backg.drawLine(XX2+Xinit,YY2+Yinit,XX3+Xinit,YY3+Yinit);
      cntx.moveTo(XX2+Xinit,YY2+Yinit);
      cntx.lineTo(XX3+Xinit,YY3+Yinit);
      //backg.drawLine(XX2+Xinit,YY2+Yinit,XX4+Xinit,YY4+Yinit);
      cntx.moveTo(XX2+Xinit,YY2+Yinit);
      cntx.lineTo(XX4+Xinit,YY4+Yinit);
      cntx.stroke();
    
      P=Math.random();
      if(P>1.0-probabilty && Counter<10){
        DrawTree1(0,XX3+Xinit,YY3+Yinit,Angle-Math.PI/12,Counter+1);            
      }
      else if(ComplexTree1 && P>(2-probabilty)/2) {
        DrawTree1(2,XX3+Xinit,YY3+Yinit,Angle-Math.PI/8,Counter+1);
      }
      else{
        DrawTree1(1,XX3+Xinit,YY3+Yinit,Angle-Math.PI/8,Counter+1);
      }
    
      P=Math.random();
      if(P>1-probabilty){
        DrawTree1(0,XX4+Xinit,YY4+Yinit,Angle+Math.PI/12,Counter+1);            
      }
      else if(ComplexTree1 && P>(probabilty)/2){
        DrawTree1(2,XX4+Xinit,YY4+Yinit,Angle+Math.PI/8,Counter+1);
      }
      else{
        DrawTree1(1,XX4+Xinit,YY4+Yinit,Angle+Math.PI/8,Counter+1);
      }
    }
    else if(Selector==1){
      if(useColors) cntx.strokeStyle=LeavesColor; //backg.setColor(LeavesColor);
      X1=0;
      Y1=-BasicSize/2;
      XX1=Rotate(X1,Y1,Angle,1);
      YY1=Rotate(X1,Y1,Angle,2);
      //backg.drawOval(XX1+Xinit-BasicSize/2,Y1+Yinit-BasicSize/2,BasicSize,BasicSize);
      cntx.beginPath();
      cntx.arc(XX1+Xinit,Y1+Yinit,BasicSize,0,2*Math.PI);
      cntx.stroke(); 
    }
    else if(Selector==2){
      if(useColors) cntx.strokeStyle=LeavesColor; //backg.setColor(LeavesColor);
      X1=-BasicSize/2;
      Y1=0;
      X2=BasicSize/2;
      Y2=0;
      X3=0;
      Y3=-BasicSize;
      
      XX1=Rotate(X1,Y1,Angle,1);
      YY1=Rotate(X1,Y1,Angle,2);
      
      XX2=Rotate(X2,Y2,Angle,1);
      YY2=Rotate(X2,Y2,Angle,2);

      XX3=Rotate(X3,Y3,Angle,1);
      YY3=Rotate(X3,Y3,Angle,2);
      
      cntx.beginPath();
      //backg.drawLine(XX1+Xinit,YY1+Yinit,XX2+Xinit,YY2+Yinit);
      cntx.moveTo(XX1+Xinit,YY1+Yinit);
      cntx.lineTo(XX2+Xinit,YY2+Yinit);
      //backg.drawLine(XX1+Xinit,YY1+Yinit,XX3+Xinit,YY3+Yinit);
      cntx.moveTo(XX1+Xinit,YY1+Yinit);
      cntx.lineTo(XX3+Xinit,YY3+Yinit);
      //backg.drawLine(XX2+Xinit,YY2+Yinit,XX3+Xinit,YY3+Yinit);
      cntx.moveTo(XX2+Xinit,YY2+Yinit);
      cntx.lineTo(XX3+Xinit,YY3+Yinit);
      cntx.stroke();
    }
 }
 
function Rotate(x1,y1,Angle,ResultSelector){
  var X2,Y2;
  if(ResultSelector==1){
    X2=parseInt(x1*Math.cos(Angle)-y1*Math.sin(Angle));
    return X2;
  }
  else{
    Y2=parseInt(x1*Math.sin(Angle)+y1*Math.cos(Angle));
    return Y2;
  }
}

function initialiseDrawingParams(){
    mouseMoving=false;
    $("#colorise").prop("checked",false);
    $("#probability").val(10);
    changeProbabilty();
}

function drawNewTree(){
    mouseMoving=false;
    drawBasicScreen();
}

function changeProbabilty(){
    mouseMoving=false;
    probabilty=parseFloat($("#probability").val())/100.0;
    drawBasicScreen();
}